'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _rax = require('rax');

var _raxView = require('rax-view');

var _raxView2 = _interopRequireDefault(_raxView);

var _raxText = require('rax-text');

var _raxText2 = _interopRequireDefault(_raxText);

var _raxTouchable = require('rax-touchable');

var _raxTouchable2 = _interopRequireDefault(_raxTouchable);

var _styles = require('./styles');

var _styles2 = _interopRequireDefault(_styles);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var Day = function (_Component) {
  _inherits(Day, _Component);

  function Day() {
    var _ref;

    var _temp, _this, _ret;

    _classCallCheck(this, Day);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref = Day.__proto__ || Object.getPrototypeOf(Day)).call.apply(_ref, [this].concat(args))), _this), _this.dayCircleStyle = function (isWeekend, isSelected, isToday) {
      var customStyle = _this.props.customStyle;

      var dayCircleStyle = [_styles2.default.dayCircleFiller, customStyle.dayCircleFiller && customStyle.dayCircleFiller];

      if (isSelected && !isToday) {
        dayCircleStyle.push(_styles2.default.selectedDayCircle, customStyle.selectedDayCircle && customStyle.selectedDayCircle);
      } else if (isSelected && isToday) {
        dayCircleStyle.push(_styles2.default.currentDayCircle, customStyle.currentDayCircle && customStyle.currentDayCircle);
      }
      return dayCircleStyle;
    }, _this.dayTextStyle = function (isWeekend, isSelected, isToday, isDisabled) {
      var customStyle = _this.props.customStyle;

      var dayTextStyle = [_styles2.default.day, customStyle.day];
      if (isDisabled) {
        dayTextStyle.push(_styles2.default.disabledDayText, customStyle.disabledDayText && customStyle.disabledDayText);
      } else if (isToday && !isSelected) {
        dayTextStyle.push(_styles2.default.currentDayText, customStyle.currentDayText && customStyle.currentDayText);
      } else if (isToday || isSelected) {
        dayTextStyle.push(_styles2.default.selectedDayText, customStyle.selectedDayText && customStyle.selectedDayText);
      } else if (isWeekend) {
        dayTextStyle.push(_styles2.default.weekendDayText, customStyle.weekendDayText && customStyle.weekendDayText);
      }
      return dayTextStyle;
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Day, [{
    key: 'render',
    value: function render() {
      var _props = this.props,
          caption = _props.caption,
          customStyle = _props.customStyle;
      var _props2 = this.props,
          filler = _props2.filler,
          hasEvent = _props2.hasEvent,
          isWeekend = _props2.isWeekend,
          isSelected = _props2.isSelected,
          isToday = _props2.isToday,
          isDisabled = _props2.isDisabled,
          usingEvents = _props2.usingEvents;


      return filler ? (0, _rax.createElement)(
        _raxTouchable2.default,
        null,
        (0, _rax.createElement)(
          _raxView2.default,
          { style: [_styles2.default.dayButtonFiller, customStyle.dayButtonFiller] },
          (0, _rax.createElement)(_raxText2.default, { style: [_styles2.default.day, customStyle.day] })
        )
      ) : (0, _rax.createElement)(
        _raxTouchable2.default,
        { onPress: !isDisabled && this.props.onPress },
        (0, _rax.createElement)(
          _raxView2.default,
          { style: [_styles2.default.dayButton, customStyle.dayButton] },
          (0, _rax.createElement)(
            _raxView2.default,
            { style: this.dayCircleStyle(isWeekend, isSelected, isToday) },
            (0, _rax.createElement)(
              _raxText2.default,
              { style: this.dayTextStyle(isWeekend, isSelected, isToday, isDisabled) },
              caption
            )
          ),
          usingEvents && (0, _rax.createElement)(_raxView2.default, { style: [_styles2.default.eventIndicatorFiller, customStyle.eventIndicatorFiller, hasEvent && _styles2.default.eventIndicator, hasEvent && customStyle.eventIndicator]
          })
        )
      );
    }
  }]);

  return Day;
}(_rax.Component);

Day.defaultProps = {
  customStyle: {}
};
Day.propTypes = {
  caption: _rax.PropTypes.any,
  customStyle: _rax.PropTypes.object,
  filler: _rax.PropTypes.bool,
  hasEvent: _rax.PropTypes.bool,
  isSelected: _rax.PropTypes.bool,
  isToday: _rax.PropTypes.bool,
  isWeekend: _rax.PropTypes.bool,
  isDisabled: _rax.PropTypes.bool,
  onPress: _rax.PropTypes.func,
  usingEvents: _rax.PropTypes.bool
};
exports.default = Day;
module.exports = exports['default'];